<CsoundSynthesizer>
<CsOptions>
</CsOptions>
<CsInstruments>


sr=96000
ksmps=64
nchnls=2
0dbfs = 1
	
;cpuprc 1, 60
	

	opcode thresh, 0, kkkkkkiii

		 
klowgain,kmidgain,khighgain,kthreshlow, kthreshhigh, kband, inumbins, iampout, iampinsmooth xin


iclear 	ftgen 0, 0, inumbins, 2, 0
	tablecopy iampout, iclear

kcount = 0
kvol = 0
kbandfixed = kband
	
loop:
kamp 	table kcount, iampinsmooth

kvol = kvol + kamp
kcount = kcount + 1

if (kcount == kband) kgoto thresh
		kgoto contin

thresh:
	kband2 = kband
	kband = kband + kbandfixed

	if (kvol < kthreshlow) kgoto low
		kgoto high
		
	low:	 
		kband3 = kband2-kbandfixed
 
		vadd  iampout, klowgain, kbandfixed, kband3
		kgoto contin

	high:
	kband3 = kband2-kbandfixed			
	if (kvol < kthreshhigh) then
		vadd  iampout, kmidgain, kbandfixed, kband3

	else
		vadd  iampout, khighgain, kbandfixed, kband3

	endif

contin:	
kvol = 0
	
	if (kcount < inumbins) kgoto loop

endop
	
instr 1

kdepth	chnget "depth"
kdepth	port kdepth, 0.01

kaver chnget	"aver"
ksmooth chnget "smooth"

kthreshHigh chnget "threshH"
kthreshLow chnget "threshL"

khighGain chnget "gainH"
khighGain	port khighGain, 0.01
khighGain = khighGain+0.0000001

kmidGain chnget "gainM"
kmidGain	port kmidGain, 0.01
kmidGain = kmidGain+0.0000001

klowGain chnget "gainL"
klowGain	port klowGain, 0.01
klowGain = klowGain+0.0000001

kBand	chnget	"band"

ain1, ain2	ins
			denorm	ain1, ain2 
ifftsize = p4
iol = p5
iNumBins = (ifftsize/2) + 1
ihop = ifftsize/iol
iwindow = ifftsize*p6

iampout ftgen 0,0,ifftsize,2,0

iampinsmooth1 ftgen 0,0,ifftsize,2,0
iampinsmooth2 ftgen 0,0,ifftsize,2,0

iampout2 ftgen 0,0,ifftsize,2,0

	
fsig1 pvsanal ain1, ifftsize, ihop, iwindow, p7
fsig2 pvsanal ain2, ifftsize, ihop, iwindow, p7

fsig3 pvsblur fsig1, kaver, 1
fsig4 pvsblur fsig2, kaver, 1
kflag pvsftw  fsig3, iampinsmooth1

if (kflag > 0) then ; only proc when frame is ready

	thresh  klowGain,kmidGain,khighGain,kthreshLow, kthreshHigh, kBand, iNumBins, iampout, iampinsmooth1

	pvsftr fsig3, iampout;, ifreqout

endif


; export fsig to tables
kflag2  pvsftw fsig4, iampinsmooth2
if (kflag2 > 0) then ; only proc when frame is ready

	thresh  klowGain,kmidGain,khighGain,kthreshLow, kthreshHigh,kBand, iNumBins, iampout2, iampinsmooth2

; read modified data back to fsrc
	pvsftr fsig4, iampout2;, ifreqout2

endif

;
fsig11 pvsmooth fsig3, ksmooth, 2
fsig22 pvsmooth fsig4, ksmooth, 2

fsig5 pvsfilter fsig1, fsig11, kdepth
fsig6 pvsfilter fsig2, fsig22, kdepth


aout1 pvsynth fsig5
aout2 pvsynth fsig6

	

outs aout1, aout2

endin	


	
	
</CsInstruments>
<CsScore>

f0 86400

e

</CsScore>
</CsoundSynthesizer>
<MacOptions>
Version: 3
Render: Real
Ask: Yes
Functions: ioObject
Listing: Window
WindowBounds: 776 613 664 178
CurrentView: io
IOViewEdit: On
Options:
</MacOptions>
<MacGUI>
ioView nobackground {59624, 59624, 59624}
ioSlider {5, 5} {20, 100} 0.000000 1.000000 0.000000 slider1
ioSlider {45, 5} {20, 100} 0.000000 1.000000 0.000000 slider2
ioSlider {85, 5} {20, 100} 0.000000 1.000000 0.000000 slider3
ioSlider {125, 5} {20, 100} 0.000000 1.000000 0.000000 slider4
ioSlider {165, 5} {20, 100} 0.000000 1.000000 0.000000 slider5
</MacGUI>

